Description

I'd like to add a url hook to Redmine's repositories so a repository can have it's fetch changesets called from a basic HTTP

GET/POST.  This could be linked up with post commit hooks or a web hook service (e.g. GitHub) to allow a repository to stay up to

date without using auto fetch commits or a scheduled rake task.

Related issues:

Related to Redmine - Feature #296: REST API Closed

Related to Redmine - Feature #3389: Increase speed of Repository.fetch_change... Closed 2009-05-19

Associated revisions

Revision 3107 - 2009-11-28 17:50 - Jean-Philippe Lang

Adds an action to SysController to fetch changesets of one or all projects (#2925).

Exemples:

/sys/fetch_changesets (=> fetches changesets for all active projects)

/sys/fetch_changeseys?id=foo (=> fetches changesets for project foo only)

History

#1 - 2009-03-07 01:57 - Eric Davis

This might need part of the REST API implemented first, specifically authentication.

#2 - 2009-03-07 09:48 - Markus Knittig

+1

Re REST API: I think the controllers need to be refactored first...

#3 - 2009-03-07 15:05 - Jean-Philippe Lang

I think we could easily add this entry point to SysController that already provides some repository related methods (used by reposman).

#4 - 2009-03-10 00:59 - Eric Davis

Jean-Philippe Lang wrote:

I think we could easily add this entry point to SysController that already provides some repository related methods (used by reposman).

 I think once REST is complete, we should remove SysController completely.  Nice side effect is that reposman would be a good example of using the

REST API.

SysController#projects would become ProjectsController#index, :format => :xml (list of projects in xml)

SysController#create_project_repository would become RepositoriesController#create, :format => :xml (create a new repository from xml)

I don't think we should just remove SysController though, it should be depreciated in order to give developers enough time to port to the REST API. 

I'm saying this because it's taken me over two weeks to recover from the Rails 2.2.x i18n and Enumeration API changes and I don't want to cause

that pain on any other developer without giving notice.

#5 - 2009-04-08 21:27 - Jean-Philippe Lang

Eric Davis wrote:

SysController#create_project_repository would become RepositoriesController#create, :format => :xml (create a new repository from xml)
 But this would require a Redmine admin account to run reposman.

I don't think it's the best solution.

#6 - 2009-04-10 08:19 - Chris Miller

I believe that if you `curl http://www.your-redmine.com/projects/your-project/repository | /dev/null` in your post-commit hook it will cause Redmine to

"look" at the repository, specifically fetch the changesets.  If you have a private project this would become crazy-complicated, however, this seems to

work for me (although I use a local Git repo on the server hard disk).

I'm not suggesting this isn't a good feature, I'm just saying that until the feature is done that a good band-aid solution exists (or exists with my setup -

YMMV).

#7 - 2009-11-28 17:44 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version set to 0.9.0

- Resolution set to Fixed

Added in r3107.

#8 - 2014-06-26 21:26 - Lukas Pirl

There is also a plugin to fetch commits for a specific repository only.
